﻿/*
	Search and change case
	Version: 1.5
	
    Script by Thomas Silkjær
	http://indesigning.net/user/files/scripts/search_change_case.jsx
*/

/*
2010. Перевод на русский язык и доработка интерфейса программы — Иванюшин М.Ю., ivanyushin#yandex.ru
- Диалог и сообщения на русском языке
- Добавлено для наглядности выражение поиска
- Регистр набранного текста — ‘нормальный текст’ / ‘все прописные’ / ‘малые прописные’  — тоже стал объектом поиска
- В оригинальной версии программа не спрашивая заменяла все буквы, отвечавшие введенному выражению поиска. 
  В этом варианте добавлен режим работы, в котором пользователь подтверждает каждую замену.
- Добавлена возможность обработки только выделенного текста
- При обработке найденных слов можно определить — заменять слово полностью, или сохранить регистр первой буквы
*/	
#target indesign
app.scriptPreferences.version = 6; 

myNORMAL = 1852797549;
mySMALL_CAPS = 1936548720;
myALL_CAPS = 1634493296;
myCAP_TO_SMALL_CAP = 1664250723; // Use OpenType small caps

myNONE = 852796517; // No conversion
myUPPERCASE = 1667462499; // Converts all letters to uppercase
myLOWERCASE	= 1667460195; // Converts all letters to lowercase
myTITLECASE = 1667462243; // Converts the first letter of each word to uppercase
mySENTENCECASE = 1667461987; // Converts the first letter of the first word of each sentence to uppercase

var myStepByStepMode = true;
var myFirstCharIsUnchanged = true;
if(app.documents.length != 0)  { // app.documents
var the_document = app.documents.item(0);
// Create a list of character styles
var list_of_character_styles = the_document.characterStyles.everyItem().name;
list_of_character_styles.unshift("Нет");

// Make the dialog box for the change case search
var the_dialog = app.dialogs.add({name:"     Изменение регистра букв (16.08.2010)"});
with(the_dialog.dialogColumns.add({})){
	with (borderPanels.add()) { //----
	with (dialogColumns.add()) { ///===	
	staticTexts.add({staticLabel:"                                                          ПОИСК                                                      "});
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"GREP-запрос поиска:       "});
		var grep_string = textEditboxes.add({minWidth:220, editContents:"\\l{2,}\\b"});
	}
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"Регистр искомого текста:"});
		var reg_string = dropdowns.add({stringList:["All Caps - все прописные","Small Caps - малые прописные","Normal - обычный текст"], selectedIndex:0});
	}
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"Пространство поиска:     "});
		var search_in = dropdowns.add({stringList:["Selection","Story","Document"], selectedIndex:0});
	}
} ///===
} //----
staticTexts.add({staticLabel:" "});
	with (borderPanels.add()) { //----+
	with (dialogColumns.add()) { ///===+
staticTexts.add({staticLabel:"ЗАМЕНА"});
//staticTexts.add({staticLabel:" "});
staticTexts.add({staticLabel:"Порядок работы с текстом                                "});
	with(dialogRows.add()) { // row
		var myMode = radiobuttonGroups.add();
			with(myMode){
				radiobuttonControls.add({staticLabel:"Подтверждать каждую замену", checkedState:true});
				radiobuttonControls.add({staticLabel:"Безусловная замена"});
			}
	} // row

	
with(dialogColumns.add({})){ ///*

//staticTexts.add({staticLabel:" "});
staticTexts.add({staticLabel:" "});
staticTexts.add({staticLabel:"При замене нескольких букв...      "});
	with(dialogRows.add()){
		var myWord = radiobuttonGroups.add();
			with(myWord){
				radiobuttonControls.add({staticLabel:"...не изменять первую букву"});
				radiobuttonControls.add({staticLabel:"...изменять все буквы", checkedState:true});				
			}
	}
} ///*
staticTexts.add({staticLabel:" "});
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"Смена регистра:      "});
		//var change_case_to_text = dropdowns.add({stringList:["UPPERCASE - ПРОПИСНЫЕ","lowercase - строчные","Title Case - Каждое Слово С Прописной","Sentence case - Первое слово с прописной","не изменять написание текста"], selectedIndex:1});
		var change_case_to_text = dropdowns.add({stringList:["UPPERCASE","lowercase","Title Case","Sentence case","не изменять"], selectedIndex:1});
	}
	with(dialogRows.add()){
		staticTexts.add({staticLabel:"Символьный стиль?  "});
		var apply_cstyle = dropdowns.add({stringList:list_of_character_styles, selectedIndex:0});
	}
	with(dialogRows.add()) {
		staticTexts.add({staticLabel:"Буквы прописными? "});
		//var local_formatting = dropdowns.add({stringList:["Нет","OpenType All Small Caps","Small Caps"], selectedIndex:0});
		//var local_formatting = dropdowns.add({stringList:["Нет","All Caps - все прописные","Small Caps - малые прописные"], selectedIndex:0});
		var local_formatting = dropdowns.add({stringList:["Нет","All Caps","Small Caps"], selectedIndex:0});
	}
} ///===+
} //----+
}
if(the_dialog.show() == false) { //cancel
	the_dialog.destroy();
	exit(); 
} //cancel  
if (myMode.selectedButton == 1) {myStepByStepMode = false};
if (myWord.selectedButton == 1) {myFirstCharIsUnchanged = false};
//Define change_case_to
if(change_case_to_text.selectedIndex == 0) {
	change_case_to = ChangecaseMode.UPPERCASE;
} else if(change_case_to_text.selectedIndex == 1) {
	change_case_to = ChangecaseMode.LOWERCASE;
} else if(change_case_to_text.selectedIndex == 2) {
	change_case_to = ChangecaseMode.TITLECASE;
} else {
	change_case_to = ChangecaseMode.SENTENCECASE;
}

// Set find grep preferences to find text with the grep value entered in the dialog
app.findChangeGrepOptions.includeFootnotes = true;
app.findChangeGrepOptions.includeHiddenLayers = false;
app.findChangeGrepOptions.includeLockedLayersForFind = false;
app.findChangeGrepOptions.includeLockedStoriesForFind = false;
app.findChangeGrepOptions.includeMasterPages = false;

app.findGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences.findWhat = grep_string.editContents;

// Search
var myInfo = grep_string;
if (grep_string.editContents.length == 0) { 
		alert("Строка \'GREP-запрос поиска:\' пустая.");
		exit();
	}
if(search_in.selectedIndex == 0) {
	var the_story = app.selection[0];
	if ((app.selection[0].constructor.name != "Text") && (app.selection[0].constructor.name != "Character") && (app.selection[0].constructor.name != "Word") && (app.selection[0].constructor.name != "Paragraph") && (app.selection[0].constructor.name != "TextColumn") && (app.selection[0].constructor.name != "TextStyleRange")) {
		alert("При выборе в поле \'Пространство поиска:\' опции Selection предполагается, что перед запуском скрипта в верстке выделен текст.");
		exit();
	}
	var found_texts = the_story.findGrep();
}
if(search_in.selectedIndex == 1) {
	var the_story = app.selection[0].parentStory;
	var found_texts = the_story.findGrep();
}
if(search_in.selectedIndex == 2) { 
	var found_texts = the_document.findGrep();
}

// Loop through found text and change the case, apply local formatting and character styles
if(found_texts.length != 0) { // found_texts.length != 0
	var myNmbr = 0;
	for (i=0;i<found_texts.length;i++) { //
		if ((reg_string.selectedIndex == 0) && (found_texts[i].capitalization != myALL_CAPS)) continue;
		if ((reg_string.selectedIndex == 1) && (found_texts[i].capitalization != mySMALL_CAPS)) continue;
		if ((reg_string.selectedIndex == 2) && (found_texts[i].capitalization != myNORMAL)) continue;

		if (myStepByStepMode == true) { //  myStepByStepMode == true
			found_texts[i].select();
			var myFork = confirm("Изменить регистр?");
			if (myFork == false) continue;
		} // myStepByStepMode == true
		if (myFirstCharIsUnchanged == true) {
			if (found_texts[i].length > 1) {
				found_texts[i].characters.itemByRange(1,(found_texts[i].length-1)).capitalization = myNORMAL;
				found_texts[i].characters.itemByRange(1,(found_texts[i].length-1)).changecase(change_case_to);
				myNmbr++;
				}
		}
		else {
			found_texts[i].capitalization = myNORMAL;
			found_texts[i].changecase(change_case_to);
			myNmbr++;
			}
		if(local_formatting.selectedIndex == 1) {
			//found_texts[i].capitalization = Capitalization.CAP_TO_SMALL_CAP;
			found_texts[i].capitalization = Capitalization.ALL_CAPS;
		} else if(local_formatting.selectedIndex == 2) {
			found_texts[i].capitalization = Capitalization.SMALL_CAPS;
		}
		if(apply_cstyle.selectedIndex != 0) {
			var the_cstyle = the_document.characterStyles.item(apply_cstyle.selectedIndex-1);
			found_texts[i].appliedCharacterStyle = the_cstyle;
		}
	} //
//	if (myStepByStepMode == false) alert("Число выполненных изменений регистра букв: "+ myNmbr +".");
	if (myNmbr !=0)  alert("Число выполненных изменений регистра букв: "+ myNmbr +".");
	else alert("При выбранном варианте поля \'Регистр искомого текста:\' ничего не найдено.");
	exit();
} // found_texts.length != 0
else {
	alert("Не найден текст, отвечающий введенному GREP-выражению поиска " + grep_string.editContents + "   ");
	 exit();
}
} // app.documents
alert("Нет открытых документов.");
exit();

